:- module( disp_bn, [disp_bn/1,disp_bn/2,bn_to_dot_dag/3,disp_bn_version/2] ).

/** <module> Construct and display BN terms via graphviz

Construct and display graphs via graphviz. Originallly for Bayesian networks (thus the name) but
can deal with all graph types supported via graphviz.

The _dot_ executable from the graphviz distributions should be in your $PATH environment variable.

Only tested on Linux systems.

@author nicos angelopoulos
@version  0.1 2021/01/19
@see http://stoics.org.uk/~nicos/sware/contact.html

*/

:- use_module( library(lib) ).
:- lib( source(disp_bn), homonyms(true) ).

:- lib( disp_bn/2 ).
:- lib( bn_to_dot_dag/3 ).

:- lib(end(disp_bn)).

/** disp_bn_version( -Vers, -Date ).

Version Mj:Mn:Fx, and release date date(Y,M,D).

==
?- disp_bn_version( V, D ).
V = 0:1:0,
D = date(2021, 1, 19).
==

@author Nicos Angelopoulos
@version  0:1 2021/1/19
@see http://stoics.org.uk/~nicos/sware/packs/disp_bn

*/
disp_bn_version( 0:1:0, date(2021,1,19) ).


                 /*******************************
                 *            MESSAGES          *
                 *******************************/
:- multifile prolog:message//1.

prolog:message(disp_bn(Message)) -->
    message(Message).

:- discontiguous
    message//1.

message( dot_off(Target) ) -->
    ['The dot executable is not installed, disp_bn/1 cannot process ~w'-[Target] ].
